#ifndef HAPTICORE_TYPES
#define HAPTICORE_TYPES

namespace HapticoreLibrary
{
	typedef enum class Register : byte
	{
		RPLY_STATUS 										= 0x00,

		CMD_REBOOT_SYSTEM									= 0x01,
		CMD_LOAD_DEFAULT_VALUES								= 0x02,
		CMD_GET_REGISTER_VALUE								= 0x03,
		CMD_DEGAUSS											= 0x04,
		CMD_CALIBRATE_ENCODER								= 0x05,
		CMD_DISABLE_ALL_HAPTIC_FUNCTIONS					= 0x08,
		CMD_CALIBRATE_PUSH_PULL								= 0x0E,

		REG_CONTROLLER_ID									= 0x10,
		REG_FW_VERSION										= 0x12,
		REG_COMMUNICATION_PROTOCOL_VERSION					= 0x13,
		REG_HAPTICORE_LIBRARY_VERSION						= 0x14,
		REG_CONTROLLER_HARDWARE_REVISION					= 0x15,
		REG_HAPTICORE_MANUFACTURER_SERIAL_NUMBER			= 0x16,
		REG_HAPTICORE_TYPE									= 0x17,
		REG_HAPTICORE_PROTOTYPE_VERSION						= 0x18,
		REG_HAPTICORE_PROTOTYPE_NUMBER						= 0x19,
		REG_HAPTICORE_PROTOTYPE_LOT							= 0x1A,
		REG_HAPTICORE_DIAMETER								= 0x1B,
		REG_HAPTICORE_PRODUCT_NUMBER						= 0x1C,
		REG_HAPTICORE_VARIANT_NUMBER						= 0x1D,
		REG_HAPTICORE_ITEM_NUMBER							= 0x1E,

		REG_OPERATINGTIME1									= 0x20,
		REG_OPERATINGTIME2									= 0x21,

		REG_ENCODER_TEMPERATURE								= 0x22,
		REG_SYSTEM_CONFIGURATION							= 0x29,

		REG_REPORT_TYPE										= 0x30,
		REG_REPORT_FLAGS									= 0x31,
		REG_REPORT_FREQUENCY								= 0x32,

		REG_LED_RGB_RED										= 0x36,
		REG_LED_RGB_GREEN									= 0x37,
		REG_LED_RGB_BLUE									= 0x38,

		REG_IDLE_DETECTION_VELOCITY_THRESHOLD				= 0x3D,
		REG_IDLE_DETECTION_TIMEOUT							= 0x3E,
		REG_IDLE_DETECTION_CURRENT_RAMP_DOWN_SLOPE			= 0x3F,

		REG_CURRENT_CONTROLLER_KP							= 0x42,
		REG_CURRENT_CONTROLLER_IDLE_CURRENT					= 0x43,
		REG_CURRENT_CONTROLLER_MODE							= 0x44,
		REG_CURRENT_CONTROLLER_KI							= 0x45,
		REG_CURRENT_CONTROLLER_COIL_RESISTANCE				= 0x46,
		REG_CURRENT_CONTROLLER_COIL_INDUCTANCE				= 0x47,
		REG_ENCODER_ANGLE_FILTER_R							= 0x48,
		REG_ENCODER_VELOCITY_FILTER_R						= 0x49,
		REG_CURRENT_CONTROLLER_SUPPLY_VOLTAGE_OVERRIDE		= 0x4A,
		REG_CURRENT_CONTROLLER_SUPPLY_VOLTAGE				= 0x4B,
		REG_COIL_DRIVER_PWM_POLARITY						= 0x4C,
		REG_COIL_DRIVER_STOP_MODE							= 0x4D,
		REG_CURRENT_SENSE_POLARITY							= 0x4E,

		REG_ENCODER_MODE									= 0x50,
		REG_ENCODER_ANGLE									= 0x51,
		REG_ENCODER_TIME_TRIGGERED_ANGLE_INCREMENT			= 0x52,
		REG_ENCODER_VELOCITY_FILTER_Q						= 0x53,
		REG_ENCODER_VELOCITY_NOISE_THRESHOLD				= 0x54,
		REG_ENCODER_DIRECTION								= 0x55,

		REG_ENCODER_ANGLE_FILTER_Q							= 0x58,
		REG_ENCODER_ANGLE_RESOLUTION						= 0x59,
		REG_ENCODER_CALIBRATION_Y_OFFSET					= 0x5A,
		REG_ENCODER_CALIBRATION_Y_AMPLITUDE					= 0x5B,
		REG_ENCODER_CALIBRATION_Z_OFFSET					= 0x5C,
		REG_ENCODER_CALIBRATION_Z_AMPLITUDE					= 0x5D,
		REG_ENCODER_OFFSET									= 0x5E,
		REG_ENCODER_SCALING									 =0x5F,

		REG_DEGAUSS_MODE									= 0x60,
		REG_DEGAUSS_FREQUENCY								= 0x61,
		REG_DEGAUSS_CURRENT									= 0x62,
		REG_DEGAUSS_DURATION								= 0x63,

		REG_PUSH_ACTIVATE_THRESHOLD							= 0x66,
		REG_PUSH_DEACTIVATE_THRESHOLD						= 0x67,
		REG_PULL_ACTIVATE_THRESHOLD							= 0x68,
		REG_PULL_DEACTIVATE_THRESHOLD						= 0x69,

		REG_TICK_INDEX_COUNT_MODE							= 0x6A,
		REG_TICK_DEGAUSS_CURRENT							= 0x6B,
		REG_TICK_DEGAUSS_DURATION							= 0x6C,
		REG_TICK_EXPONENTIAL_RAMP_DOWN_VELOCITY_THRESHOLD	= 0x6D,
		REG_TICK_EXPONENTIAL_RAMP_DOWN_FACTOR				= 0x6E,
		REG_TICK_EXPONENTIAL_RAMP_DOWN_CURRENT_MIN_PERCENT	= 0x6F,

		REG_TICK_MODE										= 0x70,
		REG_TICK_ENABLE										= 0x71,
		REG_TICK_CURRENT									= 0x72,
		REG_TICK_ANGLE_CW									= 0x73,
		REG_TICK_DURATION_MIN								= 0x74,
		REG_TICK_DURATION_MAX								= 0x75,
		REG_TICK_VELOCITY_FACTOR							= 0x76,
		REG_TICK_INDEX_WINDOW								= 0x77,
		REG_TICK_STICKINESS_PREVENTION_FACTOR				= 0x78,
		REG_TICK_ANGLE_CCW									= 0x79,
		REG_TICK_ACTIVE_DIRECTION							= 0x7A,
		REG_TICK_FREEWHEELING_VELOCITY_THRESHOLD			= 0x7B,
		REG_TICK_FREEWHEELING_EXTENSION_TIME				= 0x7C,
		REG_TICK_WINDOW										= 0x7D,
		REG_TICK_START_ANGLE								= 0x7E,
		REG_TICK_STOP_ANGLE									= 0x7F,

		REG_BARRIER_ENABLE									= 0x81,
		REG_BARRIER_CURRENT									= 0x82,
		REG_BARRIER_START_ANGLE								= 0x83,
		REG_BARRIER_STOP_ANGLE								= 0x84,

		REG_BARRIER_POLARITY								= 0x8C,
		REG_BARRIER_LIMIT_ANGLE								= 0x8D,

		REG_CURRENT_ENABLE									= 0x90,
		REG_CURRENT_START_ANGLE								= 0x91,
		REG_CURRENT_STOP_ANGLE								= 0x92,
		REG_CURRENT_START_CURRENT_CW						= 0x93,
		REG_CURRENT_STOP_CURRENT_CW							= 0x94,
		REG_CURRENT_START_CURRENT_CCW						= 0x95,
		REG_CURRENT_STOP_CURRENT_CCW						= 0x96,
		REG_CURRENT_FREEWHEELING_VELOCITY_THRESHOLD			= 0x97,
		REG_CURRENT_FREEWHEELING_EXTENSION_TIME				= 0x98,
		REG_CURRENT_ACTIVE_DIRECTION						= 0x99,

		REG_CURRENT_STREAMING_ENABLE						= 0x9A,
		REG_CURRENT_STREAMING_CURRENT						= 0x9B,

		REG_TORQUE_ENABLE									= 0xA0,
		REG_TORQUE_START_ANGLE								= 0xA1,
		REG_TORQUE_STOP_ANGLE								= 0xA2,
		REG_TORQUE_START_FACTOR_CW							= 0xA3,
		REG_TORQUE_STOP_FACTOR_CW							= 0xA4,
		REG_TORQUE_START_FACTOR_CCW							= 0xA5,
		REG_TORQUE_STOP_FACTOR_CCW							= 0xA6,
		REG_TORQUE_FREEWHEELING_VELOCITY_THRESHOLD			= 0xA7,
		REG_TORQUE_FREEWHEELING_EXTENSION_TIME				= 0xA8,
		REG_TORQUE_ACTIVE_DIRECTION							= 0xA9,

		REG_LOCK_ENABLE										= 0xB0,
		REG_LOCK_DIRECTION									= 0xB1,
		REG_LOCK_CURRENT									= 0xB2,

		REG_SINGLE_TICK_ENABLE								= 0xC0,
		REG_SINGLE_TICK_ACTIVE_DIRECTION					= 0xC1,
		REG_SINGLE_TICK_ANGLE								= 0xC2,
		REG_SINGLE_TICK_CURRENT								= 0xC3,
		REG_SINGLE_TICK_MODE								= 0xC4,
		REG_SINGLE_TICK_DURATION_MIN						= 0xC5,
		REG_SINGLE_TICK_DURATION_MAX						= 0xC6,
		REG_SINGLE_TICK_WINDOW								= 0xC7,
		REG_SINGLE_TICK_VELOCITY_FACTOR						= 0xC8,

		REG_HAPTICS_GENERATOR_ENABLE						= 0xCA,

		REG_CUSTOM_MODE_ENABLE								= 0xD0,
		REG_CUSTOM_MODE										= 0xD1,
		REG_CUSTOM_PARAMETER1								= 0xD2,
		REG_CUSTOM_PARAMETER2								= 0xD3,
		REG_CUSTOM_PARAMETER3								= 0xD4,
		REG_CUSTOM_PARAMETER4								= 0xD5,
		REG_CUSTOM_PARAMETER5								= 0xD6,
		REG_CUSTOM_PARAMETER6								= 0xD7,
		REG_CUSTOM_PARAMETER7								= 0xD8,
		REG_CUSTOM_PARAMETER1_PROPERTIES					= 0xD9,
		REG_CUSTOM_PARAMETER2_PROPERTIES					= 0xDA,
		REG_CUSTOM_PARAMETER3_PROPERTIES					= 0xDB,
		REG_CUSTOM_PARAMETER4_PROPERTIES					= 0xDC,
		REG_CUSTOM_PARAMETER5_PROPERTIES					= 0xDD,
		REG_CUSTOM_PARAMETER6_PROPERTIES					= 0xDE,
		REG_CUSTOM_PARAMETER7_PROPERTIES					= 0xDF,

		REPORT_ENCODER_ANGLE								= 0xE0,
		REPORT_ENCODER_VELOCITY								= 0xE1,
		REPORT_PUSH_PULL_VALUE								= 0xE2,
		REPORT_TICK_INDEX									= 0xE3,
		REPORT_PUSH_PULL_STATE								= 0xE4,
		REPORT_ENCODER_MULTI_TURN_COUNT						= 0xE5,
		REPORT_ENCODER_TEMPERATURE							= 0xE6,
		REPORT_COIL_CURRENT									= 0xE7,

		REPORT_DEVICE_ERROR_STATUS							= 0xEA,
		REPORT_ENCODER_CALIBRATION_STATUS					= 0xEB,

		REPORT_PUSH_CALIBRATION_STATUS						= 0xED,
		REPORT_PULL_CALIBRATION_STATUS						= 0xEE,
		REPORT_DEVICE_CONNECTION_STATE						= 0xEF,

		REPORT_SUPPLY_VOLTAGE								= 0xF4,
		REPORT_DEGAUSS_STATUS								= 0xF5,

		REG_LOOPBACK 										= 0xFF
	};

	enum class PwmPolarity : byte
	{
		PWM_POLARITY_DEFAULT = 0x00,
		PWM_POLARITY_REVERSE = 0x01
	};

	enum class CurrentSensePolarity : byte
	{
		CURRENT_SENSE_POLARITY_DEFAULT = 0x00,
		CURRENT_SENSE_POLARITY_REVERSE = 0x01
	};

	enum class StopMode : byte
	{
		BRAKE = 0x00,
		COAST = 0x01
	};

	enum class CountMode : byte
	{
		COUNT_MODE_1 = 0x0,
		COUNT_MODE_2 = 0x1
	};

	enum class ActiveDirection : unsigned short int
	{
		BOTH	= 0x00,
		CW		= 0x01,
		CCW		= 0x02
	};

	enum class BarrierPolarity : unsigned short int
	{
		START_POSITIVE_STOP_POSITIVE = 0x00,
		START_POSITIVE_STOP_NEGATIVE = 0x01,
		START_NEGATIVE_STOP_POSITIVE = 0x02,
		START_NEGATIVE_STOP_NEGATIVE = 0x03
	};

	enum CalibrationType : unsigned short int
	{
		PUSH = 0x00,
		PULL = 0x01
	};

	enum class CurrentControllerMode : unsigned short int
	{
		CCM_NONE				= 0x00,
		CCM_P					= 0x01,
		CCM_PI					= 0x02,
		CCM_SETTER				= 0x03,
		CCM_P_CURRENT_OBSERVER	= 0x04,
		CCM_PI_CURRENT_OBSERVER	= 0x05
	};

	enum class CustomMode : unsigned short int
	{
		CUSTOM_MODE_0	= 0x00,
		CUSTOM_MODE_1	= 0x01,
		CUSTOM_MODE_2	= 0x02,
		CUSTOM_MODE_3	= 0x03,
		CUSTOM_MODE_4	= 0x04,
		CUSTOM_MODE_5	= 0x05,
		CUSTOM_MODE_6	= 0x06,
		CUSTOM_MODE_7	= 0x07,
		CUSTOM_MODE_8	= 0x08,
		CUSTOM_MODE_9	= 0x09,
		CUSTOM_MODE_10	= 0x0A,
		CUSTOM_MODE_11	= 0x0B,
		CUSTOM_MODE_12	= 0x0C,
		CUSTOM_MODE_13	= 0x0D,
		CUSTOM_MODE_14	= 0x0E,
		CUSTOM_MODE_15	= 0x0F,
		CUSTOM_MODE_16	= 0x10,
		CUSTOM_MODE_17	= 0x11,
		CUSTOM_MODE_18	= 0x12,
		CUSTOM_MODE_19	= 0x13,
		CUSTOM_MODE_20	= 0x14,
		CUSTOM_MODE_21	= 0x15,
		CUSTOM_MODE_22	= 0x16,
		CUSTOM_MODE_23	= 0x17,
		CUSTOM_MODE_24	= 0x18,
		CUSTOM_MODE_25	= 0x19,
		CUSTOM_MODE_26	= 0x1A,
		CUSTOM_MODE_27	= 0x1B,
		CUSTOM_MODE_28	= 0x1C,
		CUSTOM_MODE_29	= 0x1D,
		CUSTOM_MODE_30	= 0x1E,
		CUSTOM_MODE_31	= 0x1F
	};

	enum class DegaussMode : unsigned short int
	{
		SINE_EXPONENTIAL	= 0x00,
		SINE_LINEAR			= 0x01,
		SQUARE_EXPONENTIAL	= 0x02,
		SQUARE_LINEAR	= 0x03,
	};

	enum class DegaussStatus : unsigned short int
	{
		NOT_DEGAUSSING	= 0x00,
		DEGAUSSING		= 0x01
	};

	enum class EncoderCalibrationStatus : unsigned short int
	{
		NOT_SUPPORTED	= 0x00,
		UNCALIBRATED	= 0x01,
		CALIBRATING		= 0x02,
		CALIBRATED		= 0x03,
		FAILED			= 0x04,
	};

	enum class EncoderDirection : unsigned short int
	{
		ENCODER_DIRECTION_DEFAULT = 0x00,
		ENCODER_DIRECTION_REVERSE = 0x01
	};

	enum class EncoderMode : unsigned short int
	{
		ENCODER_MODE_DEFAULT	= 0x01,
		ENCODER_MODE_EMULATION	= 0x02
	};

	enum class HapticoreDeviceConnectionState : unsigned short int
	{
		DISCONNECTED	= 0x00,
		CONNECTED		= 0x01
	};

	enum class HapticoreDeviceErrorStatus : unsigned short int
	{
		NO_ERROR								= 0x0000,
		COIL_RESISTANCE_TOO_LOW					= 0x0001,
		COIL_RESISTANCE_TOO_HIGH				= 0x0002,
		COIL_DRIVER_MAXIMUM_CURRENT_EXCEEDED	= 0x0004,
		ENCODER_COMMUNICATION_ERROR				= 0x0008,
		EEPROM_COMMUNICATION_ERROR				= 0x0010,
		COIL_DRIVER_ERROR						= 0x0020,
		COIL_MAXIMUM_TEMPERATURE_EXCEEDED		= 0x0040,
		EEPROM_CRC_INVALID						= 0x0080,
		EEPROM_INIT_ERROR						= 0x0100,
		ENCODER_DRIVER_INIT_ERROR				= 0x0200,
		ENCODER_DATA_INVALID_ERROR				= 0x0400,
		COIL_CURRENT_ERROR						= 0x0800
	};

	enum class PushPullCalibrationStatus : unsigned short int
	{
		NOT_SUPPORTED	= 0x00,
		UNCALIBRATED	= 0x01,
		CALIBRATING		= 0x02,
		CALIBRATED		= 0x03,
		FAILED			= 0x04
	};

	enum class  PushPullState : unsigned short int
	{
		NONE	= 0x00,
		PUSH	= 0x01,
		PULL	= 0x02,
		UNKNOWN	= 0x03
	};

	enum class ReplyStatus : unsigned short int
	{
		NO_ERROR					= 0x01,
		GET_REGISTER_NOT_SUPPORTED	= 0x02,
		NOT_SUPPORTED				= 0x04
	};

	enum class ReportFlags : unsigned short int
	{
		NOTHING						= 0x0000,
		ENCODER_ANGLE				= 0x0001,
		ENCODER_VELOCITY			= 0x0002,
		DEVICE_ERROR_STATUS			= 0x0004,
		TICK_INDEX					= 0x0008,
		PUSH_PULL					= 0x0010,
		ENCODER_MULTI_TURN_COUNT	= 0x0020,
		COIL_CURRENT				= 0x0040,
		ENCODER_TEMPERATURE			= 0x0080,
		STATISTICS					= 0x0100,
		ENCODER_CALIBRATION_STATUS	= 0x0200,
		COIL_RESISTANCE				= 0x0400,
		DEVICE_CONNECTION_STATE		= 0x0800,
		SUPPLY_VOLTAGE				= 0x1000,
		DEGAUSS_STATUS				= 0x2000
	};

	inline ReportFlags operator | (ReportFlags a, ReportFlags b)
	{
		return static_cast<ReportFlags>(static_cast<unsigned short int>(a) | static_cast<unsigned short int>(b));
	}

	enum class ReportType : unsigned short int
	{
		CYCLIC  = 0x00,
		ACYCLIC = 0x01
	};

	enum class TickMode : unsigned short int
	{
		TICK_MODE_1 = 0,
		TICK_MODE_2 = 1,
		TICK_MODE_3 = 2,
		TICK_MODE_4 = 3,
	};
}

#endif
